<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="品牌名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入品牌名称" />
                </el-form-item>
                <el-form-item label="拼音信息" prop="py">
                    <el-input v-model="formData.py" clearable placeholder="请输入拼音信息" />
                </el-form-item>
                <el-form-item label="品牌编号" prop="number">
                    <el-input v-model="formData.number" clearable placeholder="请输入品牌编号" />
                </el-form-item>
                <el-form-item label="备注信息" prop="data">
                    <el-input v-model="formData.data" clearable placeholder="请输入备注信息" />
                </el-form-item>
                <el-form-item label="扩展信息" prop="more">
                    <el-input v-model="formData.more" clearable placeholder="请输入扩展信息" />
                </el-form-item>
                <el-form-item label="图片" prop="pic">
                    <material-picker v-model="formData.pic" />
                </el-form-item>
                <el-form-item label="排序" prop="sort">
                    <el-input v-model="formData.sort" clearable placeholder="请输入排序" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="brandEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiBrandAdd, apiBrandEdit, apiBrandDetail } from '@/api/brand'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑品牌信息表' : '新增品牌信息表'
})

// 表单数据
const formData = reactive({
    id: '',
    name: '',
    py: '',
    number: '',
    data: '',
    more: '',
    pic: '',
    sort: '',
})


// 表单验证
const formRules = reactive<any>({
    name: [{
        required: true,
        message: '请输入品牌名称',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiBrandDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiBrandEdit(data) 
        : await apiBrandAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
